#include <lpc11xx.h>
#include "gpio.h"

void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

int main(void)
{
	uint8_t key=1;
	GPIOInit();
	GPIO_Configuration();
	while(1)
	{

 /*8IOs PIO0_11  PIO1_0..2 PIO1_4..5 PIO1_8..9*/
		if((LPC_GPIO0->DATA&(1<<11))!=(1<<11))
			key=2;
		if((LPC_GPIO1->DATA&(1<<0))!=(1<<0))
			key=3;
		if((LPC_GPIO1->DATA&(1<<1))!=(1<<1))
			key=4;
		
		if((LPC_GPIO1->DATA&(1<<2))!=(1<<2))
			key=5;
		if((LPC_GPIO1->DATA&(1<<4))!=(1<<4))
			key=5;
		if((LPC_GPIO1->DATA&(1<<5))!=(1<<5))
			key=4;
		if((LPC_GPIO1->DATA&(1<<8))!=(1<<8))
			key=3;
		if((LPC_GPIO1->DATA&(1<<9))!=(1<<9))
			key=2;

	   switch(key)
	   {
			case 0:	
			GPIOSetValue(PORT2,4,LOW);
			GPIOSetValue(PORT2,5,LOW);
			GPIOSetValue(PORT2,6,LOW);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,4,HIGH);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0x5ffff);
			break;
		
			case 1:
			GPIOSetValue(PORT2,4,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,4,HIGH);

			GPIOSetValue(PORT2,5,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,7,HIGH);
			break;

			case 2:
			GPIOSetValue(PORT2,4,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,4,HIGH);
			Delay(0x5ffff);
			break;

			case 3:
			GPIOSetValue(PORT2,5,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,5,HIGH);
			Delay(0x5ffff);
			break;

			case 4:
			GPIOSetValue(PORT2,6,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,6,HIGH);
			Delay(0x5ffff);
			break;

			case 5:
			GPIOSetValue(PORT2,7,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0x5ffff);
			break;

			case 6:
			GPIOSetValue(PORT2,4,LOW);
			GPIOSetValue(PORT2,5,LOW);
			GPIOSetValue(PORT2,6,LOW);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0x5ffff);
			GPIOSetValue(PORT2,4,HIGH);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0x5ffff);
			break;
		}	

	}	
}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/

void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT2,4,OUT);
	GPIOSetDir(PORT2,5,OUT);
	GPIOSetDir(PORT2,6,OUT);
	GPIOSetDir(PORT2,7,OUT);

 /*8IOs PIO0_11  PIO1_0..2 PIO1_4..5 PIO1_8..9*/
	GPIOSetDir(PORT0,11,IN);
	GPIOSetDir(PORT1,0,IN);
	GPIOSetDir(PORT1,1,IN);
	GPIOSetDir(PORT1,2,IN);
	GPIOSetDir(PORT1,4,IN);
	GPIOSetDir(PORT1,5,IN);
	GPIOSetDir(PORT1,8,IN);
	GPIOSetDir(PORT1,9,IN);

			
}

