#include <lpc11xx.h>
#include "gpio.h"

void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

int main(void)
{
	uint8_t key=1;
	GPIOInit();
	GPIO_Configuration();
	while(1)
	{
	/*key1(PIO1_10)  key2(PIO1_11)*/
		if((LPC_GPIO1->DATA&(1<<10))!=(1<<10))
			key=0;
		if((LPC_GPIO1->DATA&(1<<11))!=(1<<11))
			key=1;
	/*joystick  A(PIO2_8) B(PIO2_9) C(PIO2_10) D(PIO2_11) PRESS(PIO0_1)*/

		if((LPC_GPIO2->DATA&(1<<8))!=(1<<8))
			key=2;
		if((LPC_GPIO2->DATA&(1<<9))!=(1<<9))
			key=3;
		if((LPC_GPIO2->DATA&(1<<10))!=(1<<10))
			key=4;
		if((LPC_GPIO2->DATA&(1<<11))!=(1<<11))
			key=5;
		if((LPC_GPIO0->DATA&(1<<1))!=(1<<1))
			key=6;

	   switch(key)
	   {
			case 0:	
			GPIOSetValue(PORT2,4,LOW);
			GPIOSetValue(PORT2,5,LOW);
			GPIOSetValue(PORT2,6,LOW);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,4,HIGH);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0xfffff);
			break;
		
			case 1:
			GPIOSetValue(PORT2,4,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,4,HIGH);

			GPIOSetValue(PORT2,5,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,7,HIGH);
			break;

			case 2:
			GPIOSetValue(PORT2,4,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,4,HIGH);
			Delay(0xfffff);
			break;

			case 3:
			GPIOSetValue(PORT2,5,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,5,HIGH);
			Delay(0xfffff);
			break;

			case 4:
			GPIOSetValue(PORT2,6,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,6,HIGH);
			Delay(0xfffff);
			break;

			case 5:
			GPIOSetValue(PORT2,7,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0xfffff);
			break;

			case 6:
			GPIOSetValue(PORT2,4,LOW);
			GPIOSetValue(PORT2,5,LOW);
			GPIOSetValue(PORT2,6,LOW);
			GPIOSetValue(PORT2,7,LOW);
			Delay(0xfffff);
			GPIOSetValue(PORT2,4,HIGH);
			GPIOSetValue(PORT2,5,HIGH);
			GPIOSetValue(PORT2,6,HIGH);
			GPIOSetValue(PORT2,7,HIGH);
			Delay(0xfffff);
			break;
		}	

	}	
}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/

void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT2,4,OUT);
	GPIOSetDir(PORT2,5,OUT);
	GPIOSetDir(PORT2,6,OUT);
	GPIOSetDir(PORT2,7,OUT);
	/*key1(PIO1_10)  key2(PIO1_11)*/
	GPIOSetDir(PORT1,10,IN);
	GPIOSetDir(PORT1,11,IN);

	/*joystick  A(PIO2_8) B(PIO2_9) C(PIO2_10) D(PIO2_11) PRESS(PIO0_1)*/
	GPIOSetDir(PORT2,8,IN);
	GPIOSetDir(PORT2,9,IN);
	GPIOSetDir(PORT2,10,IN);
	GPIOSetDir(PORT2,11,IN);
	GPIOSetDir(PORT0,1,IN);
			
}

