#include <lpc11xx.h>
#include "ssp.h"

/*****************************************/
/* ܣSPI1ͨ                    */
/* ˵    һֽڣһֽ  */
/*****************************************/
uint8_t SPI1_communication(uint8_t TxData)
{		
	while(((LPC_SSP1->SR)&(1<<4))==(1<<4));//æʱȴ,SR״̬Ĵbit4 BSY:æʱΪ1
	LPC_SSP1->DR = TxData;                 //Ҫ͵дTxFIFO
	while(((LPC_SSP1->SR)&(1<<2))!=(1<<2));//ȴ,SR״̬Ĵbit2 RNE:FIFOǿΪ1
	return(LPC_SSP1->DR);		    	   //յ
}

/*****************************************/
/* ܣSPI0ͨ                    */
/* ˵    һֽڣһֽ  */
/*****************************************/
uint8_t SPI0_communication(uint8_t TxData)
{		
	while(((LPC_SSP0->SR)&(1<<4))==(1<<4));//æʱȴ,SR״̬Ĵbit4 BSY:æʱΪ1
	LPC_SSP0->DR = TxData;                 //Ҫ͵дTxFIFO
	while(((LPC_SSP0->SR)&(1<<2))!=(1<<2));//ȴ,SR״̬Ĵbit2 RNE:FIFOǿΪ1
	return(LPC_SSP0->DR);		    	   //յ
}

/*****************************************/
/* ܣSPI1ʼ                  */
/* ˵    ûSSEL1                 */
/*****************************************/
void SPI1_Init(void)
{
	uint8_t i,Clear=Clear;//Clear=Clear:ʽWaring:never used!	

	LPC_SYSCON->PRESETCTRL |= (1<<2);	   //ֹLPC_SSP1λ
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<18);//LPC_SSP1ʱ bit18
	LPC_SYSCON->SSP1CLKDIV = 0x06;		   //6Ƶ48/6=8Mhz

   	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16); // ʹLPC_IOCONʱ(bit16)
	LPC_IOCON->PIO2_1 &= ~0x07;
	LPC_IOCON->PIO2_1 |= 0x02;		//PIO2_1ѡΪSSP CLK 
	LPC_IOCON->PIO2_2 &= ~0x07;	
	LPC_IOCON->PIO2_2 |= 0x02;		//PIO2_2ѡΪSSP MISO 
	LPC_IOCON->PIO2_3 &= ~0x07;	
	LPC_IOCON->PIO2_3 |= 0x02;		//PIO2_3ѡΪSSP MOSI 
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16); // LPC_IOCONʱ(bit16)

	// 8λݴ䣬SPIģʽ, CPOL = 0, CPHA = 0,ʱCLIΪ1һزɼݣSCR = 0
	LPC_SSP1->CR0 = 0x0107;	    
	// ԤƵֵΪ254ע⣺СΪ2ұΪż 2~254 
	LPC_SSP1->CPSR = 0x02;
	LPC_SSP1->CR1 &= ~(1<<0);//LBM=0:ģʽ
	LPC_SSP1->CR1 &= ~(1<<2);//MS=0:ģʽ 
	LPC_SSP1->CR1 |=  (1<<1);//SSE=1:ʹSPI1
	//RxFIFOLPC1114շ8֡FIFO,ÿ֡ɷ4~16λ
	for ( i = 0; i < 8; i++ )
	{
	  	Clear = LPC_SSP1->DR;//ݼĴDRRxFIFO
	} 	
		 		  
}


/*****************************************/
/* ܣSPI0ʼ                  */
/* ˵    ûSSEL0                 */
/*****************************************/
void SPI0_Init(void)
{
	uint8_t i,Clear=Clear;//Clear=Clear:ʽWaring:never used!	

	LPC_SYSCON->PRESETCTRL |= (0x1<<0);	   //ֹLPC_SSP0λ
	LPC_SYSCON->SYSAHBCLKCTRL |= (0x1<<11);//LPC_SSP0ʱ bit11
	LPC_SYSCON->SSP0CLKDIV = 0x02;		   //ƵϵΪ1ʹSPI048Mhz
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16); // ʹLPC_IOCONʱ(bit16)
	LPC_IOCON->SCK_LOC = 0x02;      //SCK0õPIO0_6
	LPC_IOCON->PIO0_6 &= ~0x07;
	LPC_IOCON->PIO0_6 |= 0x02;		//PIO0_6ΪSSP CLK 
	LPC_IOCON->PIO0_8 &= ~0x07;	
	LPC_IOCON->PIO0_8 |= 0x01;		//PIO0_8ΪSSP MISO 
	LPC_IOCON->PIO0_9 &= ~0x07;	
	LPC_IOCON->PIO0_9 |= 0x01;		//PIO0_9ΪSSP MOSI 
	LPC_SYSCON->SYSAHBCLKCTRL &= ~(1<<16); // LPC_IOCONʱ(bit16)
	// 8λݴ䣬SPIģʽ, CPOL = 0, CPHA = 0,ʱCLKΪ0һزɼݣSCR = 0
	LPC_SSP0->CR0 = 0x0107;	    
	// ԤƵֵע⣺Ϊż 2~254 
	LPC_SSP0->CPSR = 0x02;
	LPC_SSP0->CR1 &= ~(1<<0);//LBM=0:ģʽ
	LPC_SSP0->CR1 &= ~(1<<2);//MS=0:ģʽ 
	LPC_SSP0->CR1 |=  (1<<1);//SSE=1:ʹSPI0
	//RxFIFOLPC1114շ8֡FIFO,ÿ֡ɷ4~16λ
	for ( i = 0; i < 8; i++ )
	{
	  	Clear = LPC_SSP0->DR;//ݼĴDRRxFIFO
	} 		 		  
}

