#include "LPC11xx.h"
#include "NRF24L01.h"
#include "ssp.h"
#include "stdio.h"
#include "timer32.h"


#define	RX_DR			0x40
#define	TX_DS			0x20
#define	MAX_RT			0x10

uint8_t TX_ADDRESS[TX_ADR_WIDTH] = {0xb2,0xb2,0xb3,0xb4,0x01};  // һ̬͵ַ



uint8_t RX_BUF[TX_PLOAD_WIDTH];

uint8_t TX_BUF[TX_PLOAD_WIDTH];

/*MISO and MOSI SCLK Ϊùܣ죩  SPI1  */
/*SPI NRF24L01+Ƭѡ	GPIOB_PIN_15     	CSN   	ͨģʽ */
/*SPI NRF24L01+ģʽѡ	GPIOB_PIN_14    CE		ͨģʽ*/
/*SPI NRF24L01+жź	 GPIOB_PIN_13   IRQ		ģʽ*/




static void delay1us(uint8_t t)
{
	TIM32B0_delay_us(t);
} 

/****Ĵregдһֽڣͬʱ״ֽ̬**************/
uint8_t SPI_RW_Reg(uint8_t reg,uint8_t value)
{
	uint8_t status;
	CSN_0;
	status=SPI1_communication(reg);   //select register  and write value to it
	SPI1_communication(value);   
	CSN_1;
	return(status); 
}
/****Ĵregһֽڣͬʱ״ֽ̬**************/
uint8_t SPI_Read_Reg(uint8_t reg)
{
	uint8_t status;
	CSN_0;
	SPI1_communication(reg);
	status=SPI1_communication(0);   //select register  and write value to it
	CSN_1;
	return(status);
}
/********bytesֽڵ*************************/
uint8_t SPI_Read_Buf(uint8_t reg,uint8_t *pBuf,uint8_t bytes)
{
	uint8_t status,byte_ctr;
	CSN_0;
	status=SPI1_communication(reg);       
	for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
		pBuf[byte_ctr]=SPI1_communication(0);
	CSN_1;
	return(status);
}

/****************дbytesֽڵ*******************/
uint8_t SPI_Write_Buf(uint8_t reg,uint8_t *pBuf,uint8_t bytes)
{
	uint8_t status,byte_ctr;
	CSN_0;
	status=SPI1_communication(reg); 
	delay1us(1);
	for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
		SPI1_communication(*pBuf++);
	CSN_1;
	return(status);
}

/*պ1ʾյûݽյ**/
uint8_t nRF24L01_RxPacket(uint8_t* rx_buf)
{
    uint8_t status,revale=0;
	CE_0;
	delay1us(10);
	status=SPI1_communication(STATUS);	// ȡ״̬Ĵжݽ״
//	CE_0;
//	status=0x40;
	printf("STATUS״̬0x%2x\r\n",status);

	if(status & RX_DR)				// жǷյ
	{
//		CE_1;
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
//		CE_0;
		revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG_NRF24L01 + STATUS,status);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	CE_1;
	return revale;	
}

 /****************ͺ***************************/
void nRF24L01_TxPacket(unsigned char * tx_buf)
{
	CE_0;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG_NRF24L01 + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
	SPI_RW_Reg(WRITE_REG_NRF24L01 + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	CE_1;		 //øCEݷ
	delay1us(10);
}

void RX_Mode(void)
{
	CE_0;
  	SPI_Write_Buf(WRITE_REG_NRF24L01 + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // 豸ͨ0ʹúͷ豸ͬķ͵ַ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + RX_PW_P0, TX_PLOAD_WIDTH);  // ͨ0ѡͷͨͬЧݿ 
 
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_AA, 0x3f);               // ʹܽͨ0ԶӦ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_RXADDR, 0x3f);           // ʹܽͨ0
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_CH, 40);                 // ѡƵͨ0x40

  	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_SETUP, 0x07);            // ݴ1Mbps书0dBmŴ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + CONFIG, 0x0f);              // CRCʹܣ16λCRCУ飬ϵ磬ģʽ
  	CE_1;
}

void TX_Mode(uint8_t * tx_buf)
{
	CE_0;
  	SPI_Write_Buf(WRITE_REG_NRF24L01 + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     // д뷢͵ַ
  	SPI_Write_Buf(WRITE_REG_NRF24L01 + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // ΪӦ豸ͨ0ַͷ͵ַͬ
  	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_AA, 0x3f);       // ʹܽͨ0ԶӦ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_RXADDR, 0x3f);   // ʹܽͨ0
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + SETUP_RETR, 0x0a);  // Զطʱȴ250us+86usԶط10
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_CH, 40);         // ѡƵͨ0x40
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_SETUP, 0x07);    // ݴ1Mbps书0dBmŴ
	SPI_RW_Reg(WRITE_REG_NRF24L01 + RX_PW_P0, TX_PLOAD_WIDTH);  // ͨ0ѡͷͨͬЧݿ
  	SPI_RW_Reg(WRITE_REG_NRF24L01 + CONFIG, 0x0e);      // CRCʹܣ16λCRCУ飬ϵ
	CE_1;
	delay1us(10);
} 

void nRF24L01_Initial(void)
{
	/*CE CSN Initial*/
	LPC_GPIO0->DIR|=(1<<6);
	LPC_GPIO0->DATA|=(1<<6);
	/*IRQ CSN Initial*/
	LPC_GPIO0->DIR|=(1<<9);

	LPC_GPIO0->DIR&=~(1<<8);
	LPC_GPIO0->DATA|=(1<<8);
	CSN_1;
	CE_0; 
	SPI1_Init();
}

/****************** ú********************************/
void nRF24L01_Config(void)
{

	SPI_RW_Reg(WRITE_REG_NRF24L01 + CONFIG, 0x0e); // Set PWR_UP bit, enable CRC(2 bytes) &Prim:RX. RX_DR enabled..
	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_AA, 0x3f);
	SPI_RW_Reg(WRITE_REG_NRF24L01 + EN_RXADDR, 0x3f); // Enable Pipe0
//	SPI_RW_Reg(WRITE_REG_NRF24L01 + SETUP_AW, 0x02); // Setup address width=5 bytes
//	SPI_RW_Reg(WRITE_REG_NRF24L01 + SETUP_RETR, 0x1a); // 500us + 86us, 10 retrans...
	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_CH, 40);
	SPI_RW_Reg(WRITE_REG_NRF24L01 + RF_SETUP,0x07); // TX_PWR:0dBm, Datarate:2Mbps,
}
 
void NRF24L01_Send(void)
{
    uint8_t status=0x00;
	TX_Mode(TX_BUF);
	while(IRQ);
	CE_0;
	delay1us(10);
	status=SPI_Read_Reg(STATUS);	// ȡ״̬Ĵжݽ״
	if(status&TX_DS)	/*tx_ds == 0x20*/
	{
		printf("STATUS=0x%2x\r\n",status);
			
		SPI_RW_Reg(WRITE_REG_NRF24L01 + STATUS, 0x20);      // TXIRQͣ	
	}
	else if(status&MAX_RT)
		{
			printf("Send to achieve maximum number of sending!!\r\n");	
			SPI_RW_Reg(WRITE_REG_NRF24L01 + STATUS, 0x10);      // TXIRQͣ			
		}
	CE_1;
}

void NRF24L01_Receive(void)
{   
    uint8_t status=0x01;  
	SPI1_Init();
	RX_Mode();
	while(IRQ);
	CE_0;
	delay1us(10);
	status=SPI_Read_Reg(STATUS);	// ȡ״̬Ĵжݽ״
	printf("STATUS=0x%x\r\n",status);
	if(status & 0x40)			//жϱ־λ
	{
		SPI_Read_Buf(RD_RX_PLOAD,RX_BUF,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		SPI_RW_Reg(WRITE_REG_NRF24L01 + STATUS, 0x40);      // TXIRQ
		printf("Receiving data:0x%x\r\n",RX_BUF[0]);	
	}  
	CE_1;

}









