#include "timer32.h"
#include "gpio.h"
#include <lpc11xx.h>
#include "uart.h"

#define KEY1_TOGGLE  ((LPC_GPIO1->DATA&(1<<10))!=(1<<10))
#define KEY2_TOGGLE  ((LPC_GPIO1->DATA&(1<<11))!=(1<<11))
//joystick
#define JOYA_TOGGLE ((LPC_GPIO2->DATA&(1<<8))!=(1<<8))
#define JOYB_TOGGLE ((LPC_GPIO2->DATA&(1<<9))!=(1<<9))
#define JOYCTR_TOGGLE ((LPC_GPIO0->DATA&(1<<1))!=(1<<1))
#define JOYC_TOGGLE ((LPC_GPIO2->DATA&(1<<10))!=(1<<10))
#define JOYD_TOGGLE ((LPC_GPIO2->DATA&(1<<11))!=(1<<11))

void GPIO_Configuration(void);

int main()
{
	uint8_t duty=50;
	uint32_t cycle_us=10000;
	UART_init(115200);

	GPIO_Configuration();

	TIM32B0_init();	 // ʹܶʱTIM32B0
	TIM32B0_PWM(cycle_us, duty);	 // P1.6ռձΪ50%100Hzź
    printf("JOYSTICK-AռձȣJOYSTICK-Bռձ\r\n");
    printf("duty=%d\n\r",duty);
	
	while(1)
	{
		if(KEY1_TOGGLE)	
		{
			if(duty<99)
			{
				duty=duty+2;
				LPC_TMR32B0->MR0 = 48*cycle_us*(100-duty)/100; //Set occupies emptiescompared
				printf("duty=%d\r\n",duty);
			}
			
			while(KEY1_TOGGLE);
		}
		else if(KEY2_TOGGLE)	 
		{
			if(duty>1)
			{
				duty=duty-2;
				LPC_TMR32B0->MR0 = 48*cycle_us*(100-duty)/100;//Set occupies emptiescompared
				printf("duty=%d\r\n",duty);
			}
			while(KEY2_TOGGLE);	 // Waiting for release button
		}
	}
}


/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/

void GPIO_Configuration(void)
{
	/* LED0(PIO2_7)  LED0(PIO2_6)  LED0(PIO2_5)  LED0(PIO2_4) */
	GPIOSetDir(PORT2,4,OUT);
	GPIOSetDir(PORT2,5,OUT);
	GPIOSetDir(PORT2,6,OUT);
	GPIOSetDir(PORT2,7,OUT);
	/*key1(PIO1_10)  key2(PIO1_11)*/
	GPIOSetDir(PORT1,10,IN);
	GPIOSetDir(PORT1,11,IN);

	/*joystick  A(PIO2_8) B(PIO2_9) C(PIO2_10) D(PIO2_11) PRESS(PIO0_1)*/
	GPIOSetDir(PORT2,8,IN);
	GPIOSetDir(PORT2,9,IN);
	GPIOSetDir(PORT2,10,IN);
	GPIOSetDir(PORT2,11,IN);
	GPIOSetDir(PORT0,1,IN);
			
}

