/*********************************************************************************************************
*
* File                : ws_AT45DBXX.h
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

typedef uint8_t  u8;
typedef uint16_t  u16;
typedef uint32_t  u32;

extern uint8_t AT_RETURN_CODE[4];

#ifndef _AT45DBXX_H
#define _AT45DBXX_H
#include "ssp.h"

#define Open_SPI0
//#define Open_SPI1 

#ifdef Open_SPI0
	#define SPIx_communication SPI0_communication
#else 
	#define SPIx_communication SPI1_communication
#endif


#define BUF1_WRITE 0x84
#define BUF2_WRITE 0x87
#define BUF1_READ 0xD4
#define BUF2_READ 0xD6
#define BBUF1_TO_MM_PAGE_PROG_WITH_ERASE 0x83
#define BBUF2_TO_MM_PAGE_PROG_WITH_ERASE 0x86
#define MM_PAGE_TO_B1_XFER 0x53
#define MM_PAGE_TO_B2_XFER 0x55
#define PAGE_ERASE 0x81   // 512/528 bytes per page
#define SECTOR_ERASE 0x7C // 128k bytes per sector
#define READ_STATE_REGISTER 0xD7    ///0x57//0xD7
#define Read_ID 0x9F

#ifdef Open_SPI0
	//PIO0_2
	#define AT45DBXX_Enable 	 AT45DBXX_nCS_L
	#define AT45DBXX_Disable 	 AT45DBXX_nCS_H
	#define AT45DBXX_nCS_L    LPC_GPIO0->DIR |= (0x01<<2);LPC_GPIO0->DATA &= ~(0x01<<2)
	#define AT45DBXX_nCS_H    LPC_GPIO0->DIR |= (0x01<<2);LPC_GPIO0->DATA |=  (0x01<<2)	
#else
	//PIO2_0
	#define AT45DBXX_Enable 	 AT45DBXX_nCS_L
	#define AT45DBXX_Disable 	 AT45DBXX_nCS_H
	#define AT45DBXX_nCS_L    LPC_GPIO2->DIR |= (0x01<<0);LPC_GPIO2->DATA &= ~(0x01<<0)
	#define AT45DBXX_nCS_H    LPC_GPIO2->DIR |= (0x01<<0);LPC_GPIO2->DATA |=  (0x01<<0)
#endif


void AT45DBXX_Init(void);
/*static */void AT45DBXX_BUSY(void);
void AT45DBXX_Read_ID(u8 *Data);
void write_buffer(u16 BufferOffset,u8 Data);
u8 read_buffer(u16 BufferOffset);

#endif /*_AT45DBXX_H*/

